// Standard headers for all XModules (change the definition of XMODKIT_DIR in
// the Makefile to the directory where these are located) 
#import "XModule.h"
#import "XModule_defs.h"
#import "Value.h"


@interface ColorPanelXModule : XModule
{
}

// Creating and Initializing the XModule instance
- init;
- free;

// Standard XModule methods that will be over-ridden in most cases
+ (const char *)moduleName;
+ (const char **)xCmdsAndFcns;
- prepareToExecuteHandlers;
- executeHandler:(NXAtom)handlerName;

// Some helpful stuff for loading interface data and other resources
+ finishLoading:(struct mach_header *)header;
- loadInterfaceData;

- cp_alpha;		// Function, returns a color value.
- cp_color;		// Function, returns a color value.
- cp_doesShowAlpha;	// Returns a bool value of the showalpha of colorpanel.
- cp_isContinuous;	// Boolean handler.  Is the panel continuous.
- cp_mode;		// Returns the mode of the color panel.

- cp_setColor;		// Handler, used to set value.
- cp_setContinuous;	// Sets the continuous of the color panel.
- cp_setShowAlpha;	// Boolean handler.
- cp_setMode;		// Sets the mode of the color panel.

- cp_functions;
- cp_infoPanel;
- cp_version;

@end
