/*
 * (C) 1990 by Adobe Systems Incorporated. All rights reserved.
 *
 * This file may be freely copied and redistributed as long as:
 *   1) This entire notice continues to be included in the file, 
 *   2) If the file has been modified in any way, a notice of such
 *      modification is conspicuously indicated.
 *
 * PostScript, Display PostScript, and Adobe are registered trademarks of
 * Adobe Systems Incorporated.
 * 
 * ************************************************************************
 * THE INFORMATION BELOW IS FURNISHED AS IS, IS SUBJECT TO CHANGE WITHOUT
 * NOTICE, AND SHOULD NOT BE CONSTRUED AS A COMMITMENT BY ADOBE SYSTEMS
 * INCORPORATED. ADOBE SYSTEMS INCORPORATED ASSUMES NO RESPONSIBILITY OR 
 * LIABILITY FOR ANY ERRORS OR INACCURACIES, MAKES NO WARRANTY OF ANY 
 * KIND (EXPRESS, IMPLIED OR STATUTORY) WITH RESPECT TO THIS INFORMATION, 
 * AND EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR PARTICULAR PURPOSES AND NONINFINGEMENT OF THIRD PARTY RIGHTS.
 * ************************************************************************
 */

/*
 *	ControlPoint.h
 */

#import <objc/Object.h>

/* Define a type for FILL and STROKE. Used in setting the button titles */
typedef  BOOL  OP;
#define FILL				YES
#define STROKE			NO		

#define FIGURESIZE		8			/* Size of figures (needed for bitmap) */
#define FONTSIZE		5

#define RECTSIZE		4			/* Needed for rect ops */
#define RECTOFFSET		2			/* Needed for rect ops */

@interface ControlPoint:Object
{		
	char		fontchar;
	char		*basicProc, *basicOp, *userOp, *rectOp, *userOpsArray;
	float		*userPtsArray;
	id		controlView;
}

- setControlView:anObject;

- setRectfill:sender;
- setRectstroke:sender;
- setX:sender;
- setCross:sender;

- deviceDependence:(BOOL) dependent;

- selectFont:(int) fontsize;
- (char) getChar;

- (char *) getBasicProc;
- (char *) getBasicOp;

- (float *) getUserPtsArray;
- (char *) getUserOpsArray;
- (char *) getUserOp;

- (char *) getRectOp;

-drawBitMap:bitMapId;

@end

