//
// Copyright 1993 (c) Todd Anthony Nathan.  All Rights Reserved.
//

#import "XModule.h"
#import "XModule_defs.h"
#import "Value.h"


@interface EventStatusDriver : XModule
{
}

// Creating and Initializing the XModule instance
- init;
- free;

// Standard XModule methods that will be over-ridden in most cases
+ (const char *)moduleName;
+ (const char **)xCmdsAndFcns;
- prepareToExecuteHandlers;
- executeHandler:(NXAtom)handlerName;

// Some helpful stuff for loading interface data and other resources
+ finishLoading:(struct mach_header *)header;
- loadInterfaceData;


// Keyboard Methods
- ESD_setkeyrepeatinterval;
- ESD_KEYREPEATINTERVAL;
- ESD_setkeyrepeatthreshold;
- ESD_KEYREPEATTHRESHOLD;
- ESD_setkeymapping;
- ESD_KEYMAPPINGLENGTH;
- ESD_GETKEYMAPPING;
- ESD_resetkeyboard;

// Mouse Methods
- ESD_setclicktime;
- ESD_CLICKTIME;
- ESD_setclickspace;
- ESD_GETCLICKSPACE;
- ESD_setmousescaling;
- ESD_GETMOUSESCALING;
- ESD_enablemousebutton;
- ESD_MOUSEBUTTONENABLED;
- ESD_resetmouse;

// Screen Methods
- ESD_setautodimthreshold;
- ESD_AUTODIMTHRESHOLD;
- ESD_AUTODIMTIME;
- ESD_setautodimstate;
- ESD_AUTODIMSTATE;
- ESD_setscreenbrightness;
- ESD_SCREENBRIGHTNESS;
- ESD_setautodimbrightness;
- ESD_AUTODIMBRIGHTNESS;

// Volume Methods
- ESD_setcurrentvolume;
- ESD_CURRENTVOLUME;

// Wait Cursor Methods
- ESD_setwaitcursorthreshold;
- ESD_WAITCURSORTHRESHOLD;
- ESD_setwaitcursorsustain;
- ESD_WAITCURSORSUSTAIN;
- ESD_setwaitcursorframeinterval;
- ESD_WAITCURSORFRAMEINTERVAL;

- ESD_version;

@end
