
// Standard headers for all XModules (change the definition of XMODKIT_DIR in
// the Makefile to the directory where these are located) 
#import "XModule.h"
#import "XModule_defs.h"
#import "Value.h"


@interface FoneTones: XModule
{
	BOOL		soundCanPlay;
	BOOL		foneTonesAreLoaded;
}


// Creating and Initializing the XModule instance
- init;
- free;

// Standard XModule methods that will be over-ridden in most cases
+ (const char *)moduleName;
+ (const char **)xCmdsAndFcns;
- prepareToExecuteHandlers;
- executeHandler:(NXAtom)handlerName;

// Some helpful stuff for loading interface data and other resources
+ finishLoading:(struct mach_header *)header;
- loadInterfaceData;

// XModule Specific Methods
- dial;
- rememberNumber;
- forgetNumber;
- numbersStartingWith;
- allPhoneNumbers;
- phoneBook;
- phoneBooks;
- switchToBook;
- speedDialing;
- preloadTones:sender;
- preloadTones;
- phoneBookEditor;
- ft_version;

// ESD Support
- currentVolume;
- setCurrentVolume;

// FoneTones XModule Support Methods
- loadPhoneBook:(const char *)newBook;

@end
