/*
 * (C) 1990 by Adobe Systems Incorporated. All rights reserved.
 *
 * This file may be freely copied and redistributed as long as:
 *   1) This entire notice continues to be included in the file, 
 *   2) If the file has been modified in any way, a notice of such
 *      modification is conspicuously indicated.
 *
 * PostScript, Display PostScript, and Adobe are registered trademarks of
 * Adobe Systems Incorporated.
 * 
 * ************************************************************************
 * THE INFORMATION BELOW IS FURNISHED AS IS, IS SUBJECT TO CHANGE WITHOUT
 * NOTICE, AND SHOULD NOT BE CONSTRUED AS A COMMITMENT BY ADOBE SYSTEMS
 * INCORPORATED. ADOBE SYSTEMS INCORPORATED ASSUMES NO RESPONSIBILITY OR 
 * LIABILITY FOR ANY ERRORS OR INACCURACIES, MAKES NO WARRANTY OF ANY 
 * KIND (EXPRESS, IMPLIED OR STATUTORY) WITH RESPECT TO THIS INFORMATION, 
 * AND EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR PARTICULAR PURPOSES AND NONINFINGEMENT OF THIRD PARTY RIGHTS.
 * ************************************************************************
 */


/*
 * StrokeView.h
 *
 * This class, a subclass of view, contains the methods to draw horizontal, 
 * verticle and diagonal lines with stroke adjustment turned on and turned 
 * off.  
 *
 */

#import <appkit/View.h>
#define BACKGROUND    1.0
#define BORDERWIDTH   2.0
#define BORDERCOLOR   0.0
#define LINECOLOR     0.0

#define NUMLINESHORIZ  22
#define NUMLINESVERT   21
#define NUMARCS        10
#define DIAGDEGS       10

@interface StrokeView:View
{	
	id		timeDisplay, fieldWidth, matrixLineTypes;
	
	BOOL	strokeAdjustment;
}

+ newFrame:(NXRect *) frm;
- free;

/* Used to obtain the ids of certain objects for messaging from 
 * StrokeView.m. */
- setTimeDisplay:anObject;
- setFieldWidth:anObject;
- setMatrixLineTypes:anObject;

- setStrokeAdjustment:(BOOL) strokeAdjValue;

/* Draws the background, the border and the horizontal, verticle and 
 * diagonal lines. */
- drawSelf:(NXRect *)r :(int) count;

@end
