#
# TCL script for use with tcldiald.  Used to put unix host into SLIP mode.
# Originally contributed by Mark Crispin.

# $Id: login-unix.tcl,v 4.6 1992/09/05 02:00:00 louie Rel $

# The user id to log in is passed as the 1st argument
set userid [lindex $args 1]

# The password to log in is passed as the 2nd argument
set passwd [lindex $args 2]

# Set default timeout for expect command
set timeout 20

log "Begin Unix login"

# In case autobaud
xmit "\r"
sleep 1
xmit "\r"
sleep 1

# Look for unix login prompt
expect timeout {error "waiting for login"} "*ogin:*"

# Send login poop
xmit "$userid\r"
expect timeout {error "waiting for password"} "*assword:*"
sleep 1
xmit "$passwd\r"

# Wait for connection
set timeout 60
expect timeout {error "waiting for SLIP startup"} "*connected*"
set timeout 20

log "Entering SLIP mode"

# That's all
return "Connected"
