#  TCL script for use with tcldiald.  
#
#  Used to put UOnet into SLIP mode.  This version does not expect any login
#  or password promps.  If these are present with you server,
#  you can pick up additional arguments from the $args array and use
#  them to specify user name and password.  See the documentation and
#  additional sample scripts in /usr/dialupip/config/SAMPLES for ideas.
#
#  $Id: login-uonet.tcl,v 0.9 1992/10/12 01:59:47 audun@doek.uoregon Rel $
#
log "Begin UOnet login"
#
# set parity of transmitted data
#
parity ZERO
#
#  Sometimes its necessary to poke at UOnet a couple of
#  times before it responds with its prompt
#
set timeout 20
xmit {\r}
sleep 1
xmit {\r}
#
#  look for UOnet prompt
#
expect timeout {error "Couldn't get UOnet> prompt from UOnet server"} "*UOnet>*"

#
#  send command to put cisco-ts2 into SLIP mode
#
xmit "slip\r"
log "Entering SLIP mode"
#
#  Use regular-expression based expect command to match addresses in message
#  that the cisco server emits.
#
rexpect {Your IP address is ([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)}
#
#  We now ifconfig the interface, using the IP address given us from
#  cisco-ts2/UOnet
#
exec /etc/ifconfig $interface $1
#
log "My IP address should be $1"
#
# wait a bit for server to switch to SLIP mode
#
sleep 3
#
# that's all
return "End of login-uonet script - Connected"
