# tcldiald TCL script used to dial an HSD 96/24X FaxMaster modem with hardware handshake enabled
# The phone number to dial is passed as the 0'th argument

set number [lindex $args 0]

# Set default timeout for expect/rexpect commands
set timeout 2

log "Start of HSD FaxMaster dialing script"

#Set transmit to 8 bits, no parity
parity ZERO

# Flush any pending command
xmit {\r}
sleep 1


# Initialize to AT commands for HSD FaxMaster Hardware handshake with SPEAKER ON
# to dial with the speaker off change the change M1 to M0
xmit {AT&FL0&C1M0&D2S0=6S11=50%C1\\C1\\J0\\N3\\Q3\\V1 \r}
expect timeout {error "waiting for OK from modem initialization for hardware handshake"} "*OK*"


# Dial the SLIP providers number
log "Dialing $number"
xmit "ATDT$number\r"

# Wait for connect message
set timeout 35
expect timeout {error "waiting for connect"} \
	 "{*CONNECT*}" {log "Connected"}

# All OK
log "FaxMaster Connected normally"
