#  tcldiald TCL script used to establish a SLIP connection.
#
#  The general idea is that we invoke three other scripts from this file to
#  do the dirty work.  The first, hooks.tcl, sets up some TCL procedures
#  which will be invoked by diald when certain events occur.  The next
#  script, 'dial-zyxel.tcl' in this case, is responsible for configuring and
#  dialing the modem.  The third script, 'login-annex.tcl' in this case, is
#  responsible for putting the remote device in SLIP mode.  There is nothing
#  magic about how this is done, and in fact, everything could be in this
#  one file, if necessary or desirable.
#
# $Id: slip-srv.script.tcl,v 4.6 1992/09/05 01:59:50 louie Rel $
#
log "Begin annex.tcl for interface $interface site $site"

#
# invoke 'hooks.tcl' script which contains default hooks and other
# setup stuff
#
source "/usr/dialupip/config/hooks.tcl"

#
# invoke modem specific script to configure and dial the modem
#
source "/usr/dialupip/config/dial-zyxel.tcl"
#source "/usr/dialupip/config/dial-multitech.tcl"

#
# and now invoke another script to actually log in and put the line into
# SLIP mode.
#
source "/usr/dialupip/config/login-annex.tcl"

