#  tcldiald TCL script used to establish a SLIP connection.
#
#  The general idea is that we invoke three other scripts from this file to
#  do the dirty work.  The first, hooks.tcl, sets up some TCL procedures
#  which will be invoked by diald when certain events occur.  The next
#  script, 'dial-hsd.tcl' in this case, is responsible for configuring and
#  dialing the modem.  The third script, 'login-digex.tcl' in this case, is
#  responsible for putting the remote device in SLIP mode.  There is nothing
#  magic about how this is done, and in fact, everything could be in this
#  one file, if necessary or desirable.
#
#
log "Source scripts hooks.tcl,dial-hsd.tcl, and login-digex.tcl from slip-srv.script.tcl for interface $interface site $site"

#
# invoke 'hooks.tcl' script which contains default hooks and other
# setup stuff
#
log "Now invoking hooks.tcl script."
source "/usr/dialupip/config/hooks.tcl"
#
# invoke modem specific script to configure and dial the modem
#
#log "Now invoking dial-hsd.tcl script."
#source "/usr/dialupip/config/dial-hsd.tcl"
log "Now invoking dial-zyxel.tcl script."
source "/usr/dialupip/config/dial-zyxel.tcl"
#
# and now invoke another script to actually log in and put the line into SLIP mode.
#
log "Now invoking login-digex.tcl script."
source "/usr/dialupip/config/login-digex.tcl"

